clearlog()
-----------------------------------------------------------------------------------
print("--Demo ab EEP17.2 mit TouchPortal von b_maik (2024) V0.1")
-----------------------------------------------------------------------------------

-----------------------------------------------------------------------------------
--Definitionen fuer Touch-Modul----------------------------------------------------
-----------------------------------------------------------------------------------
require("b_maik_Module\\b_maik-TouchPortal-Modul")	--b_maik Touch-Modul, erforderlich
--Touch-Denitionen Pfade & Dateien, von Rechner und EEP-Version abhaengig!!
--PfadTouchDaten = "D:\\Trend\\EEP17\\LUA\\b_maik_Module\\Touch\\
-- EEP 17 auf D:
--###########################################################################################
PfadTouchDaten="D:\\Trend\\EEP17\\LUA\\b_maik_Module\\Touch\\"	--GrundPfad fuer Touchmodul
--###########################################################################################
TouchToWrite = PfadTouchDaten.."eepoutput.txt"					--Datei Output Handling an Touch
TouchToRead = PfadTouchDaten.."eepinput.txt"					--Datei Input Befehl aus Touch
TouchToWriteInfo = PfadTouchDaten.."eepoutinfo.txt"				--Datei Output Infos an Touch
TouchToWriteCam = PfadTouchDaten.."eepoutcam.txt"				--Datei Output statische Kameras an Touch
TouchToWriteFZ = PfadTouchDaten.."eepoutfz.txt"					--Datei Output FZ an Touch
TouchToWriteExtraCam = PfadTouchDaten.."eepoutextracam.txt"		--Datei Output Extra-Cam an Touch
-----------------------------------------------------------------------------------
--Initialisierung Variablen
TouchInput ={}													--Tabelle, Befehle & Parameter von Touch
TouchOutput = {}												--Tabelle, Rueckmeldung an Touch
TouchOutputInfo = {}											--Tabelle, Info/Staus-Meldungen an Touch
TouchInfoBoard = "keine aktuellen Nachrichten"  				--Text, fuer Infobox auf Touch
TouchInfoAnzahlZuege = 0			 							--Zahl, Zuege aus Depots auf Anlage
TouchInfoAnzahlDepot = 0			 							--Zahl, Anzahl Zuege in Depots bekannt
TouchInfoAnlagenName = "Demo"									--Text, Anlagename der Anlage
TouchInfoDepotStatus = "off"			 						--Text, Depotbetrieb off/on der Anlage
TouchInfoDepotSignal = 25			 							--Zahl, Signalnr Depotbetrieb der Anlage, 1=off, 2=on

--Startbedingungen Touch setzen
TouchState = "off"												--Status Handshake Touch
TouchFunktion = "off"											--Touchfunktion on/off
TouchClearFile(TouchToWrite)									--Datenfile Rueckmeldung an Touch leeren
TouchClearFile(TouchToRead)										--Datenfile Befehle & Parameter von Touch leeren
TouchClearFile(TouchToWriteInfo)								--Datenfile Info/Staus-Meldungen an Touch leeren
TouchWriteFile(TouchToWrite,"off")								--Status an Touch
TouchPrintAusgabe = 2											--Zahl, Touch - Befehle in Ereignisfenster ausgeben, 1 = nein, 2 = ja

--Tabelle TouchDepotInfo{} zur Definition der an Touch zu uebergebenden Depotdaten
TouchDepotInfo = {								--Tabelle der Depots zum uebertragen an Touch
				--	[Bordnr] = {Depotnr,Infotext},	
					[1] ={1,"Ost"},			--{Depotnr,Infotext},		
					[2] ={2,"West"},		--{Depotnr,Infotext},
					[3] ={3,"FZ-Depot West"},		--{Depotnr,Infotext},
					[4] ={4,"FZ-Depot Ost"},			--{Depotnr,Infotext},
					[5] ={5,"Test"},			--{Depotnr,Infotext},
					}
TouchCamInfo = {"Uebersicht","1","2","3","Depot1","Depot2","BUE","Windrad","Kran"}	--	Liste statischer Kameras fuer Touch
TouchFZInfo = {"#VW T6 Polizei Gruen DL1","#VW T6 Polizei Gruen DL1;001","#VW T6 Feuerwehr DL1","#Schaltauto;001",
				"#Schaltauto","#Limousine_11;001","#Limousine_11",}	--	Liste Fahrzeuge fuer Touch
--Ende Touch-Denitionen------------------------------------------------------------
-----------------------------------------------------------------------------------

-----------------------------------------------------------------------------------
-- Definitionen fuer Demo-Anlage
-----------------------------------------------------------------------------------

AutoSig = 24		--FS Automatik, 1= ein, 2=aus
Depot1Sig = 10		--Steuersignal Depot 1
Depot2Sig = 12		--Steuersignal Depot 2
I=0

-----------------------------------------------------------------------------------
--Signale registrieren und Funktionen fuer Demo-Anlage
-----------------------------------------------------------------------------------
EEPRegisterSignal(TouchInfoDepotSignal)
EEPRegisterSignal(Depot1Sig)
EEPRegisterSignal(Depot2Sig)
_ENV["EEPOnSignal_"..TouchInfoDepotSignal] = function(Stellung)
												if Stellung == 1 then 
													TouchInfoDepotStatus = "off"		 --Text  Depotbetrieb off der Anlage
												elseif Stellung == 2 then
													TouchInfoDepotStatus = "on"			 --Text  Depotbetrieb on der Anlage
												end
											end
_ENV["EEPOnSignal_"..Depot1Sig] = function(Stellung)
												if Stellung == 2 then 
													EEPSetSignal(Depot1Sig,1)
												end
											end	
_ENV["EEPOnSignal_"..Depot2Sig] = function(Stellung)
												if Stellung == 2 then 
													EEPSetSignal(Depot2Sig,1)
												end	
											end	
-----------------------------------------------------------------------------------
-----------------------------------------------------------------------------------
--Startbedingungen
-----------------------------------------------------------------------------------
											
EEPSetSignal(TouchInfoDepotSignal,1,1)												
EEPSetSignal(AutoSig,2,1)												
function TouchDatenInfo ()	--Zusatzinfo an Touch, anlagenspezifisch, was ihr damit macht in Touch ?
-- ab 31 frei definierbar
	TouchOutputInfo[31] = AutoSig..","..math.floor(EEPGetSignal(AutoSig))				--24, 1,2, Fs-Automatik
end
-----------------------------------------------------------------------------------
-----------------------------------------------------------------------------------
--Hauptschleife EEPMain
-----------------------------------------------------------------------------------
function EEPMain()
	I = I+1
	TouchDatenInfo ()	--Zusatzinfo an Touch melden
	TouchMain()			--Touch-Modul Haptschleife aufrufen
	if I%150 == 0 and TouchInfoDepotStatus == "on" then	--Depotsteuerung
			EEPSetSignal(Depot1Sig,2)
			EEPSetSignal(Depot2Sig,2)
	end	

	return 1
end
-----------------------------------------------------------------------------------

print("#####################################")
print("Main Demo TouchPortal bereit")
print("#####################################")