-----------------------------------------------------------------------------------
-- Touch-Modul zur Nutzung mit TouchPortal-Anwendung
-- von b_mail (2024)
-----------------------------------------------------------------------------------
---Depot-Info schreiben
--Funktion TouchAnzeigeZugDepot() zum generieren der Uebergabedaten an Touch fuer Zugdepots in Tabelle TouchDepotInfo
function TouchAnzeigeZugDepot()
  if TouchDepotInfo then
	local depotNr, x,n
	TouchInfoAnzahlZuege = 0														--Anzahl Zuege aus auf Anlage
	TouchInfoAnzahlDepot = 0			 											--Anzahl Zuege in Depots bekannt
	TouchInfobordDateiA = PfadTouchDaten.."\\Infobord\\Bord_Alle_Fahrt.txt"			--Dateiname für Bord-Nr Alle Fahrt
	TouchClearFile(TouchInfobordDateiA)												--Datei für Bord Alle Fahrt leeren
	local outa = assert(io.open(TouchInfobordDateiA,"a"))							--Datei für Bord Alle Fahrt oeffnen zum anhaengen
	for x = 1,#TouchDepotInfo do													--alle InfoBords befüllen
		TouchInfobordDateiW = PfadTouchDaten.."\\Infobord\\Bord_"..x.."_Warten.txt"	--Dateiname für Bord-Nr Warten
		TouchInfobordDateiF = PfadTouchDaten.."\\Infobord\\Bord_"..x.."_Fahrt.txt"	--Dateiname für Bord-Nr Fahrt
		TouchClearFile(TouchInfobordDateiW)											--Datei für Bord-Nr Warten leeren
		TouchClearFile(TouchInfobordDateiF)											--Datei für Bord-Nr unterwegs leeren
		local outw = assert(io.open(TouchInfobordDateiW,"a"))						--Datei für Bord-Nr Warten oeffnen zum anhaengen
		local outf = assert(io.open(TouchInfobordDateiF,"a"))						--Datei für Bord-Nr unterwegs oeffnen zum anhaengen
		depotNr = TouchDepotInfo[x][1]												--Depotnr aus TouchDepotInfo lesen
		outw:write("Warten Depot #"..depotNr..": "..TouchDepotInfo[x][2])			--Kopfzeile Warten schreiben
		outw:write("\n")															--Zeilenumbruch in Datei warten schreiben
		outf:write("In Fahrt aus Depot #"..depotNr..": "..TouchDepotInfo[x][2])		--Kopfzeile unterwegs schreiben
		outf:write("\n")															--Zeilenumbruch in Datei unterwegs schreiben
		local anzahl = EEPGetTrainyardItemsCount(depotNr)							--Anzahl Züge in Depot ermitteln
		for n = 1, anzahl do														--Status fuer alle Zuege in Depot lesen
			local name = EEPGetTrainyardItemName(depotNr, n)						--Zugnamen ermitteln
			if name then
				local status = EEPGetTrainyardItemStatus(depotNr, name, 0)				--status ermitteln
				TouchInfoAnzahlDepot = TouchInfoAnzahlDepot + 1			 				--Anzahl Zuege in Depots bekannt +1
				if status == 1 then														--Status = Zug in Depot
						outw:write(name)												--Zeile in Datei warten schreiben
						outw:write("\n")												--Zeilenumbruch in Datei warten schreiben
				else																	--Status = Zug nicht in  Depot
						TouchInfoAnzahlZuege = TouchInfoAnzahlZuege + 1			 		--Anzahl Zuege auf Anlage +1
						outf:write(name)												--Zeile in Datei unterwegs schreiben
						outf:write("\n")												--Zeilenumbruch in Datei unterwegs schreiben
						outa:write(name)												--Zeile in Datei Alle Fahrt schreiben
						outa:write("\n")												--Zeilenumbruch in Datei Alle Fahrt schreiben
				end
			end	
		end
		outf:close()																--Datei für Bord-Nr Fahrt schliessen
		outw:close()																--Datei für Bord-Nr Warten schliessen
	end	
	outa:close()--Datei für Bord Alle Fahrt schliessen
  end	
end

-----------------------------------------------------------------------------------
--Definitionen
-----------------------------------------------------------------------------------
TouchTakt = 0		--Touchtakt
Zug = ""
TouchTrigger2 = 0
-----------------------------------------------------------------------------------

-----------------------------------------------------------------------------------
--Funktion TouchMain(), aufruf zyklisch in EEPMain()
-----------------------------------------------------------------------------------
function TouchMain()
	TouchTakt = TouchTakt + 1
	if TouchTakt%5 == 0 then					--jede Sekunde an Touch melden
		TouchInfo()
	end
	if TouchTakt%25 == 0 then					--alle 5 Sekunden an Touch melden
		TouchAnzeigeZugDepot()
	end
	TouchReadfile(TouchToRead)
	if TouchInput[1] and TouchState == "on" then
		TouchState = "off"
		TouchClearFile(TouchToWrite)
		TouchWriteFile(TouchToWrite,"off")		--Status an Touch melden
		TouchBefehl()
	elseif  not TouchInput[1] and TouchState == "off" then
		TouchState = "on"
		TouchClearFile(TouchToWrite)
		TouchWriteFile(TouchToWrite,"on")		--Status an Touch melden
	end

	if TouchTakt == 50 then						--beim Starten nach 10 sec 1 x ausfuehren
		TouchTrigger2 = 1
		TouchCamStaticInfo()
		TouchFZInfoWrite()	
		TouchExtraCamInfo()
		TouchClearFile(TouchToWrite)
		TouchWriteFile(TouchToWrite,"on")
	end	
end
-----------------------------------------------------------------------------------

-----------------------------------------------------------------------------------
--Funktion TouchInfo(), Meldungen an Touch
--reservierte Vorgaben fuer Infozeilen 1-30, ab 31 frei verwendbar
-----------------------------------------------------------------------------------
function TouchInfo()																		--Anlageninfos an Touch melden
		local Zug = EEPGetTrainActive()
		TouchOutputInfo[1] = string.format("%02d:%02d:%02d", EEPTimeH, EEPTimeM,EEPTimeS)	--Infozeile 1 fuer Touch EEP-Zeit
		TouchOutputInfo[2] = TouchInfoBoard													--Infozeile 2 fuer Touch Infobox  
		TouchOutputInfo[3] = Zug 															--Infozeile 3 fuer Touch merken , aktiver Zug
		ok, vi = EEPGetTrainSpeed(Zug, false)												--aktuelle Ist-V Zug aktueller Zug in Steurtdialog
		ok, vs= EEPGetTrainSpeed(Zug, true) 												--aktuelle Soll-V Zug aktueller Zug
		TouchOutputInfo[4] = math.floor(vi)													--Infozeile 4 fuer Touch merken , aktuelle V Zug
		TouchOutputInfo[5] = math.floor(vs) 												--Infozeile 5 fuer Touch merken , Soll V Zug
		ok, TouchOutputInfo[6] = EEPGetTrainRoute(Zug) 										--Infozeile 6 fuer Touch merken , Route Zug
		ok, tl = EEPGetTrainLength(Zug)														--Laenge Zug aktueller Zug
		TouchOutputInfo[7] = math.floor(tl) 												--Infozeile 7 fuer Touch , Laenge Zug
		TouchOutputInfo[8] = TouchInfoAnzahlZuege											--Infozeile 8 ,Anzahl Zuege auf Anlage
		TouchOutputInfo[9] = EEPGetAnlName()												--Infozeile 9 ,Anlagenname
		TouchOutputInfo[10] = string.format("%.1f",EEPVer)									--Infozeile 10 ,EEP Version
		TouchOutputInfo[11] = PfadTouchDaten												--Infozeile 11 ,Pfad Touch in EEP
		TouchOutputInfo[12] = TouchInfoAnzahlDepot											--Infozeile 12 ,Anzahl Zuege in Depots bekannt
		TouchOutputInfo[13] = TouchInfoDepotStatus											--Infozeile 13 ,Depots in Betrieb
		TouchOutputInfo[14] = TouchInfoDepotSignal											--Infozeile 14 , Signalnummer zum Schalten Depots off/on
		TouchOutputInfo[15] = TouchTrigger2													--Infozeile 15 , Trigger 2
		TouchOutputInfo[16] = TouchState													--Infozeile 16 , Touchstate eep_bereit "on"/"off"
		TouchOutputInfo[17] = TouchTrigger2													--Infozeile 17 , Trigger 2
		
		for i = 18,30 do
			TouchOutputInfo[i] = "reserviert"												--Infozeile  ,reserviert fuer Modulerweiterung
		end	
		for i = 31,200 do																	--Infozeilen frei, ggf erhoehen
			if not TouchOutputInfo[i] then													--Infozeile nicht definiert/benutzt
				TouchOutputInfo[i] = "frei"													--Infozeile  ,frei
			end
		end	
		TouchClearFile(TouchToWriteInfo)													--Infodatei leeren
		for k,v in pairs (TouchOutputInfo) do												--Alle Eintraege aus Tabelle an Touch
			TouchWriteFile(TouchToWriteInfo,TouchOutputInfo[k])								--Zeile mit Zeilenumbruch in Infodatei schreiben
		end
end
-----------------------------------------------------------------------------------
function TouchCamStaticInfo()									--Info statische Kameras an Touch
		TouchClearFile(TouchToWriteCam)							--Cam-Datei leeren
		for k,v in pairs (TouchCamInfo) do						--Alle Eintraege aus Tabelle an Touch
			TouchWriteFile(TouchToWriteCam,v)					--Zeile mit Zeilenumbruch in Infodatei schreiben
		end
end
-----------------------------------------------------------------------------------
function TouchFZInfoWrite()										--Info Fahrzeuge an Touch
		TouchClearFile(TouchToWriteFZ)							--FZ-Datei leeren
		for k,v in pairs (TouchFZInfo) do						--Alle Eintraege aus Tabelle an Touch
			TouchWriteFile(TouchToWriteFZ,v)					--Zeile mit Zeilenumbruch in Infodatei schreiben
		end
end
-----------------------------------------------------------------------------------
function TouchExtraCamInfo()									--Info Extra-cam an Touch, wenn Modul genutzt
	TouchClearFile(TouchToWriteExtraCam)						--Extra-Cam-Datei leeren
	local text
	if Extra_Cam then											--Tabelle Extra_Cam vorhanden
		for cam_Gruppe, Cam_Liste in pairs(Extra_Cam) do		--Alle Eintraege aus Tabelle Extra_Cam an Touch
				i = 1
				for i = 1,98 do
					if Extra_Cam[cam_Gruppe][i] then
						text = cam_Gruppe..","..i..","..Extra_Cam[cam_Gruppe][i][2]
						TouchWriteFile(TouchToWriteExtraCam,text)--Zeile mit Zeilenumbruch in Infodatei schreiben
					end
				end
		end
	end	
end

function TouchResetCamera() 									--Kamera freigeben
		ok, cam_Pos_X, cam_Pos_Y, cam_Pos_Z =  EEPGetCameraPosition()
		ok, cam_Rot_X, cam_Rot_Y, cam_Rot_Z =  EEPGetCameraRotation()
		ok = EEPSetCameraPosition(cam_Pos_X, cam_Pos_Y, cam_Pos_Z )
		ok = EEPSetCameraRotation(cam_Rot_X, cam_Rot_Y, cam_Rot_Z)
end
-----------------------------------------------------------------------------------

-----------------------------------------------------------------------------------
--Funktion TouchBefehl() - Touch-Befehl auswerten, erweiterbar
--Lesen Tabelle TouchInput{}
--Zeile 1 = Befehl,
--alle weiteren Zeilen = noetige Parameter fuer Befehl
-----------------------------------------------------------------------------------
--Befehlsumsetzung
--Hier nötige Befehle eintragen, EEP-Funktionen oder eigene
TouchBefehlsListe = {
						["EEPSetSwitch"] 			= {EEPSetSwitch},
						["EEPSetSignal"] 			= {EEPSetSignal},
						["EEPStructureSetAxis"] 	= {EEPStructureSetAxis},
						["EEPStructureAnimateAxis"] = {EEPStructureAnimateAxis},
						["EEPSetTrainSpeed"] 		= {EEPSetTrainSpeed},
						["EEPRollingstockSetAxis"] 	= {EEPRollingstockSetAxis},
						["EEPSetPerspectiveCamera"] = {EEPSetPerspectiveCamera},
						["EEPSetCamera"] 			= {EEPSetCamera},
						["TouchFZInfoWrite"] 		= {TouchFZInfoWrite},
						["TouchResetCamera"] 		= {TouchResetCamera},
						["SetExtra_Cam"] 			= {SetExtra_Cam},
						["TagStructureSaveBue"] 	= {TagStructureSaveBue},
}

function TouchBefehl()
	if TouchBefehlsListe[TouchInput[1]] then			--Befehlserkennung , in Tabelle TouchBefehlsListe
			local para={}
			local AnzahlTouchPara = 0
			if TouchPrintAusgabe == 2 then print("TouchBefehl erkannt : ",TouchInput[1]) end
			for i = 1,10 do										--aktuell 10 moegliche Parameter
				if TouchInput[i+1] then							--ab Zeile 2, Pruefung ob Parameter uebergeben?
					AnzahlTouchPara = AnzahlTouchPara + 1
					if tonumber(TouchInput[i+1]) ~= nil then	--Parameter auf Zahl pruefen
						para[i]= tonumber(TouchInput[i+1])		--als Zahl uebergeben
					else
						para[i]= (TouchInput[i+1])				--als string uebergeben
					end

				if TouchPrintAusgabe == 2 then	print("parameter= ",i," :",para[i])	end
				end	
			end
			if TouchPrintAusgabe == 2 then print("AnzahlTouchPara = ",AnzahlTouchPara) end
			Befehl = {touch = TouchBefehlsListe[TouchInput[1]][1]}	--Befehlsdefinition
			if AnzahlTouchPara == 0 then						--je nach Anzahl uebergebener Parameter
				Befehl.touch()									--Funktion ohne Parameter
			elseif	AnzahlTouchPara == 1 then	
				Befehl.touch(para[1])							--Funktion mit 1 Parameter
			elseif	AnzahlTouchPara == 2 then	
				Befehl.touch(para[1],para[2])					--Funktion mit 2 Parameter
			elseif	AnzahlTouchPara == 3 then	
				Befehl.touch(para[1],para[2],para[3])			--Funktion mit 3 Parameter
			elseif	AnzahlTouchPara == 4 then	
				Befehl.touch(para[1],para[2],para[3],para[4])	--Funktion mit 4 Parameter
			elseif	AnzahlTouchPara == 5 then	
				Befehl.touch(para[1],para[2],para[3],para[4],para[5])	--Funktion mit 5 Parameter
			elseif	AnzahlTouchPara == 6 then	
				Befehl.touch(para[1],para[2],para[3],para[4],para[5],para[6])	--Funktion mit 6 Parameter
			elseif	AnzahlTouchPara == 7 then	
				Befehl.touch(para[1],para[2],para[3],para[4],para[5],para[6],para[7])	--Funktion mit 7 Parameter
			elseif	AnzahlTouchPara == 8 then	
				Befehl.touch(para[1],para[2],para[3],para[4],para[5],para[6],para[7],para[8])	--Funktion mit 8 Parameter
			elseif	AnzahlTouchPara == 9 then	
				Befehl.touch(para[1],para[2],para[3],para[4],para[5],para[6],para[7],para[8],para[9])	--Funktion mit 9 Parameter
			elseif	AnzahlTouchPara == 10 then	
				Befehl.touch(para[1],para[2],para[3],para[4],para[5],para[6],para[7],para[8],para[9],para[10])	--Funktion mit 10 Parameter
			end
	end
	TouchInput ={}				--Input-Tabelle leeren
	TouchClearFile(TouchToRead)	--Input-Datei leeren
end
-----------------------------------------------------------------------------------
--Datei-Handling fuer Touch
-----------------------------------------------------------------------------------
--Funktion TouchWriteFile(ftw,wert), Datei schreiben
--Datei ftw oeffnen
--Zeile wert in Datei anhaengen mit Zeilenumbruch Datei schreiben
--Datei schliessen
function TouchWriteFile(ftw,wert,cl)
    out = assert(io.open(ftw,"a"))
    out:write(wert)
    out:write("\n")
	out:close()
end

-----------------------------------------------------------------------------------
--Funktion TouchWriteFile(ftr), Datei lesen
--Datei ftr oeffnen
--alle Zeilen lesen, in Tabelle TouchInput{} schreiben
--Datei schliessen
function TouchReadfile(ftr)
    local inp=assert(io.open(ftr,"r"))
	for s in inp:lines()  do
			TouchInput[#TouchInput + 1] = s
	end	
	inp:close()	
end

-----------------------------------------------------------------------------------
--Funktion TouchClearFile(ftc), Datei leeren
--Datei ftc leeren
function TouchClearFile(ftc)
	out=assert(io.open(ftc,"w+"))
    out:close()
end
-----------------------------------------------------------------------------------
--Ende Datei-Handling------------------------------------------------------------------
-----------------------------------------------------------------------------------
print("#####################################")
print("Modul TouchPortal bereit")
print("#####################################")
